JobSub - Feature #22164

Upgrade jobsub code to use argparse instead of optparse
03/19/2019 11:08 AM - Shreyas Bhat
Description
We want to use argparse to get jobsub ready to move to python 3. Some pointers for upgrading optparse to argparse are here:

https://docs.python.org/2.7/library/argparse.html#upgrading-optparse-code

With some playing around, it looks like opts, args = parser.parse_args() in optparse can become args, extras =
parser.parse_known_args() pretty easily.

Related issues:
Blocks JobSub - Bug #21031: jobsub_submit allows more than one --group argument Work in progre$$/29/2018

History

#1 - 03/19/2019 11:09 AM - Shreyas Bhat

- Blocks Bug #21031: jobsub_submit allows more than one --group argument added

#2 - 04/03/2019 05:06 PM - Shreyas Bhat

- Status changed from New to Work in progress

#3 - 04/10/2019 11:37 AM - Shreyas Bhat

jobsub_fetchlog, jobsub_submit, and jobsub_g done and tested.

#4 - 04/16/2019 04:32 PM - Shreyas Bhat

jobsub_history done and tested.

#5 - 04/26/2019 03:34 PM - Shreyas Bhat
- % Done changed from 0 to 20

jobsub_hold and jobsub_probe_url done and tested.

#6 - 04/26/2019 05:03 PM - Shreyas Bhat

Rough outline of steps for each client module:

.imports (optparse, callbacks, version, etc)

. Usage line: %prog --> %(prog)s

. optparse --> argparse

. OptionParser --> ArgumentParser

.version_string: Comment out, add argument for Version_String

. opt_group --> client_options

. optparse.OptionGroup --> parser.add_argument_group; remove later parser.add_argument_group line
.add_option --> add_argument

. Change all types from strings to callables (like 'string' should become str)

. Change callbacks (action = callback --> action = actual callback class)

. Check that there's no "store_true" actions with metavars - argparse doesn't support that
. parser.parse_args --> parser.parse_known_args

. logSupport.dPrint.....: options --> vars(options)

O©o0ONOOhWN =

_
W= o

05/26/2019 12



https://docs.python.org/2.7/library/argparse.html#upgrading-optparse-code

#7 - 05/16/2019 04:55 PM - Shreyas Bhat

The rest of the client code is updated, but my dev client/server isn't working as | expected. | assume it's something to do with the incommon/curl
issues we'd seen. I'll first rebase the work here off of current master, since I'd need to anyway, and then troubleshoot my dev server.
